# -*- encoding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2010 OpenERP Italian Community (<http://www.openerp-italia.org>). 
#    All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv
from osv import fields

class crm_lead_it(osv.osv):
    _inherit = 'crm.lead'

    _columns = {
        'province': fields.many2one('res.province', string='Province'),
        'region': fields.many2one('res.region', string='Region'),
    }

    def on_change_city(self, cr, uid, ids, city):
        res = {'value':{}}
        if(city):
            city_id = self.pool.get('res.city').search(cr, uid, [('name', '=', city.title())])
            if city_id:
                city_obj = self.pool.get('res.city').browse(cr, uid, city_id[0])
                res = {'value': {
                    'province':city_obj.province_id.id,
                    'region':city_obj.region.id,
                    'zip': city_obj.zip,
                    'country_id': city_obj.region.country_id.id,
                    'city': city.title(),
                    }}
        return res

    def _set_vals_city_data(self, cr, uid, vals):
        if vals.has_key('city') and not vals.has_key('province') and not vals.has_key('region'):
            if vals['city']:
                city_obj= self.pool.get('res.city')
                city_ids = city_obj.search(cr, uid, [('name', '=', vals['city'].title())])
                if city_ids:
                    city = city_obj.browse(cr, uid, city_ids[0])
                    if not vals.has_key('zip'):
                        vals['zip'] = city.zip
                    if city.province_id:
                        vals['province'] = city.province_id.id
                    if city.region:
                        vals['region'] = city.region.id
                        if city.region.country_id:
                            vals['country_id'] = city.region.country_id.id
        return vals

    def create(self, cr, uid, vals, context=None):
        vals = self._set_vals_city_data(cr, uid, vals)
        return super(crm_lead_it, self).create(cr, uid, vals, context)

    def write(self, cr, uid, ids, vals, context=None):
        vals = self._set_vals_city_data(cr, uid, vals)
        return super(crm_lead_it, self).write(cr, uid, ids, vals, context)
    
crm_lead_it()
